=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpAnsibleClient
  class ContentCollectionVersionsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a collection version
    # ViewSet for Ansible Collection.
    # @param ansible_collection_version [AnsibleCollectionVersion] 
    # @param [Hash] opts the optional parameters
    # @return [AnsibleCollectionVersionResponse]
    def create(ansible_collection_version, opts = {})
      data, _status_code, _headers = create_with_http_info(ansible_collection_version, opts)
      data
    end

    # Create a collection version
    # ViewSet for Ansible Collection.
    # @param ansible_collection_version [AnsibleCollectionVersion] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AnsibleCollectionVersionResponse, Integer, Hash)>] AnsibleCollectionVersionResponse data, response status code and response headers
    def create_with_http_info(ansible_collection_version, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentCollectionVersionsApi.create ...'
      end
      # verify the required parameter 'ansible_collection_version' is set
      if @api_client.config.client_side_validation && ansible_collection_version.nil?
        fail ArgumentError, "Missing the required parameter 'ansible_collection_version' when calling ContentCollectionVersionsApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/ansible/collection_versions/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(ansible_collection_version) 

      # return_type
      return_type = opts[:return_type] || 'AnsibleCollectionVersionResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentCollectionVersionsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List collection versions
    # ViewSet for Ansible Collection.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :is_highest is_highest
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :namespace namespace
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :q q
    # @option opts [String] :repository_version repository_version
    # @option opts [String] :repository_version_added repository_version_added
    # @option opts [String] :repository_version_removed repository_version_removed
    # @option opts [String] :tags tags
    # @option opts [String] :version version
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedansibleCollectionVersionResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List collection versions
    # ViewSet for Ansible Collection.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :is_highest is_highest
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :namespace namespace
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :q q
    # @option opts [String] :repository_version repository_version
    # @option opts [String] :repository_version_added repository_version_added
    # @option opts [String] :repository_version_removed repository_version_removed
    # @option opts [String] :tags tags
    # @option opts [String] :version version
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedansibleCollectionVersionResponseList, Integer, Hash)>] PaginatedansibleCollectionVersionResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentCollectionVersionsApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/ansible/collection_versions/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'is_highest'] = opts[:'is_highest'] if !opts[:'is_highest'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'namespace'] = opts[:'namespace'] if !opts[:'namespace'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'tags'] = opts[:'tags'] if !opts[:'tags'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedansibleCollectionVersionResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentCollectionVersionsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a collection version
    # ViewSet for Ansible Collection.
    # @param ansible_collection_version_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [AnsibleCollectionVersionResponse]
    def read(ansible_collection_version_href, opts = {})
      data, _status_code, _headers = read_with_http_info(ansible_collection_version_href, opts)
      data
    end

    # Inspect a collection version
    # ViewSet for Ansible Collection.
    # @param ansible_collection_version_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(AnsibleCollectionVersionResponse, Integer, Hash)>] AnsibleCollectionVersionResponse data, response status code and response headers
    def read_with_http_info(ansible_collection_version_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentCollectionVersionsApi.read ...'
      end
      # verify the required parameter 'ansible_collection_version_href' is set
      if @api_client.config.client_side_validation && ansible_collection_version_href.nil?
        fail ArgumentError, "Missing the required parameter 'ansible_collection_version_href' when calling ContentCollectionVersionsApi.read"
      end
      # resource path
      local_var_path = '{ansible_collection_version_href}'.sub('{' + 'ansible_collection_version_href' + '}', CGI.escape(ansible_collection_version_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AnsibleCollectionVersionResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentCollectionVersionsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
