=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpAnsibleClient
  class PulpAnsibleGalaxyApiCollectionsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # ViewSet for Collections.
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :deprecated deprecated
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :namespace namespace
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedCollectionResponseList]
    def list(path, opts = {})
      data, _status_code, _headers = list_with_http_info(path, opts)
      data
    end

    # ViewSet for Collections.
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :deprecated deprecated
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :namespace namespace
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedCollectionResponseList, Integer, Hash)>] PaginatedCollectionResponseList data, response status code and response headers
    def list_with_http_info(path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleGalaxyApiCollectionsApi.list ...'
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PulpAnsibleGalaxyApiCollectionsApi.list"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/{path}/api/v3/collections/'.sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'deprecated'] = opts[:'deprecated'] if !opts[:'deprecated'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'namespace'] = opts[:'namespace'] if !opts[:'namespace'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedCollectionResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleGalaxyApiCollectionsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # ViewSet for Collections.
    # @param name [String] 
    # @param namespace [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [CollectionResponse]
    def read(name, namespace, path, opts = {})
      data, _status_code, _headers = read_with_http_info(name, namespace, path, opts)
      data
    end

    # ViewSet for Collections.
    # @param name [String] 
    # @param namespace [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(CollectionResponse, Integer, Hash)>] CollectionResponse data, response status code and response headers
    def read_with_http_info(name, namespace, path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleGalaxyApiCollectionsApi.read ...'
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling PulpAnsibleGalaxyApiCollectionsApi.read"
      end
      # verify the required parameter 'namespace' is set
      if @api_client.config.client_side_validation && namespace.nil?
        fail ArgumentError, "Missing the required parameter 'namespace' when calling PulpAnsibleGalaxyApiCollectionsApi.read"
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PulpAnsibleGalaxyApiCollectionsApi.read"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/{path}/api/v3/collections/{namespace}/{name}/'.sub('{' + 'name' + '}', CGI.escape(name.to_s).gsub('%2F', '/')).sub('{' + 'namespace' + '}', CGI.escape(namespace.to_s).gsub('%2F', '/')).sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'CollectionResponse' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleGalaxyApiCollectionsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a Collection object.
    # @param name [String] 
    # @param namespace [String] 
    # @param path [String] 
    # @param body [Object] 
    # @param [Hash] opts the optional parameters
    # @return [CollectionResponse]
    def update(name, namespace, path, body, opts = {})
      data, _status_code, _headers = update_with_http_info(name, namespace, path, body, opts)
      data
    end

    # Update a Collection object.
    # @param name [String] 
    # @param namespace [String] 
    # @param path [String] 
    # @param body [Object] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CollectionResponse, Integer, Hash)>] CollectionResponse data, response status code and response headers
    def update_with_http_info(name, namespace, path, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpAnsibleGalaxyApiCollectionsApi.update ...'
      end
      # verify the required parameter 'name' is set
      if @api_client.config.client_side_validation && name.nil?
        fail ArgumentError, "Missing the required parameter 'name' when calling PulpAnsibleGalaxyApiCollectionsApi.update"
      end
      # verify the required parameter 'namespace' is set
      if @api_client.config.client_side_validation && namespace.nil?
        fail ArgumentError, "Missing the required parameter 'namespace' when calling PulpAnsibleGalaxyApiCollectionsApi.update"
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PulpAnsibleGalaxyApiCollectionsApi.update"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling PulpAnsibleGalaxyApiCollectionsApi.update"
      end
      # resource path
      local_var_path = '/pulp_ansible/galaxy/{path}/api/v3/collections/{namespace}/{name}/'.sub('{' + 'name' + '}', CGI.escape(name.to_s).gsub('%2F', '/')).sub('{' + 'namespace' + '}', CGI.escape(namespace.to_s).gsub('%2F', '/')).sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      # return_type
      return_type = opts[:return_type] || 'CollectionResponse' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpAnsibleGalaxyApiCollectionsApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
